module IRC
  class UserInfo
    class << self
      def parse(hostmask)
        hostmask = hostmask.to_s
        if hostmask.empty?
          nil
        elsif hostmask[/^(.*?)!(.*?)@(.*)$/]
          new *$~[1..-1]
        else
          new hostmask
        end
      end
    end
    
    attr_reader :nickname, :username, :hostname
    
    def initialize(nickname, username = nil, hostname = nil)
      @nickname, @username, @hostname = nickname, username, hostname
    end
    
    def to_s
      "#{nickname}!#{username || "*"}@#{hostname || "*"}"
    end
  end
end
